clear 
record_trajectories = 1;
plot_trajectories = 0;
output_forecasts_dir = 'c:\\natdemand2009\\peakforecasts\\outputs';
%corrections data. I've called these xxxx1 to help when debugging.
%Variables within functions are called xxxx
corrections1 = importdata('addins.csv',',',1);
cor_years1 = corrections1.data(:,1);
%Which years to omit from historical regression. Use all extreme summer
%data, and use 2008 summer data.
omit_list = {[2001 2003 2008] [2001 2003] [] [2001 2003 2008]};
ref_year = 2008;
rand('twister',12345);
seasonal_peaks = load_all_seasonal_dumps('c:\\natdemand2009\\peakforecasts\\inputs\\');
%Above is a 21 cell array consisting of the historic data for 20 regions,
%and one cell consisting of the 4 more nested cells of actual tiwai data
%each cell has columns "year" from 1997-present, peak data for each year,
%and total power for each year.
all_energy_forecasts = load_energy_forecasts('c:\\natdemand2009\\peakforecasts\\inputs\\');
%Above is a 20 cell array with one cell for each region (no actual tiwai
%here). Each cell has a year column from present to 2050, a column of
%average forecast, and 10000 possibel forecasts.
all_regions = {'Auckland' 'BayOfPlenty' 'Canterbury' 'Central' 'HawkesBay' 'NelsonMarlborough' 'NorthIsthmus' 'OtagoSouthland' 'SouthCanterbury' 'Taranaki' 'Waikato' 'Wellington' 'WestCoast' 'UNI' 'LNI' 'LSI' 'USI' 'NI' 'SI' 'all'};
all_seasons = {'Annual' 'Summer' 'extreme_summer' 'Winter'};
for i = 1:size(all_regions,2)
    region = all_regions{i} %#ok<NOPTS>
    for jj = 1:size(all_seasons,2)
        season = all_seasons{jj};
        regression_results = regress_old_peaks(seasonal_peaks{i},ref_year,jj,omit_list{jj},cor_years1,corrections1.data(:,i+1));
        switch i
            case 8
                kk = 1;
            case 20
                kk=2;
            case 16
                kk=3;
            case 19
                kk=4;
            otherwise
                kk=5;
        end

        if kk ~= 5
            regression_results_actual_tiwai = regress_old_peaks(seasonal_peaks{21}{kk},ref_year,jj,omit_list{jj},cor_years1,corrections1.data(:,i+1));
        else
            regression_results_actual_tiwai = regression_results;
        end
        energy_forecast_region = all_energy_forecasts{i}; %check that the order of regions is consistent
        [prediction_results, trajectories] = predict_future_peaks(regression_results,energy_forecast_region,1,5,0.2,0,5,0,0.1,record_trajectories,cor_years1,corrections1.data(:,i+1));
        dump_predictions(prediction_results, regression_results_actual_tiwai,strcat(output_forecasts_dir, '\\',season,'\\peak_forecast_',season,'_',region,'_matlab.csv'));
        if plot_trajectories ==1
            plot_predictions(prediction_results, regression_results_actual_tiwai,2020,'Years',0,0,trajectories);
        else
            plot_predictions(prediction_results, regression_results_actual_tiwai,2020,'Years');
        end
        
        %save images as png files.
        saveas(gcf, strcat(output_forecasts_dir,'\\',season,'\\',region,'Graph'), 'png')
    end
end

