%load_energy_forecasts
function energy_result = load_energy_forecasts(directory)
    %we encounter the field naming issue. It's important that the regions
    %list here is consistent with the other regions lists. Note it's
    %alphabetical
    regions = {'Auckland' 'BOP' 'canterbury' 'Central' 'HawkesBay' 'NelsonMarlborough' 'NorthIsthmus' 'OtagoSouthland' 'SouthCanterbury' 'Taranaki' 'Waikato' 'Wellington' 'WestCoast'};
    energy_result = cell(size(regions,2),1);
   
    for i = 1:size(regions,2)
        energy_result{i} = load_one_energy_forecast(strcat(directory,'energy_forecast_',regions{i},'.txt'));
    end
    %This is where typo errors might occur. Match up the indices to the
    %regions list above.
    UNI_list = {energy_result{1} energy_result{7}};
    LNI_list = {energy_result{2} energy_result{4} energy_result{5} energy_result{10} energy_result{11} energy_result{12}};
    USI_list = {energy_result{3} energy_result{6} energy_result{9} energy_result{13}};
    LSI_list = {energy_result{8}};
    NI_list = cat(2,UNI_list,LNI_list);
    SI_list = cat(2,USI_list,LSI_list);
    all_list = cat(2,SI_list,NI_list);
    %This is a list of lists. Each upper level element is a list of all the
    %contributing areas to the larger region.
    region_list = {UNI_list LNI_list USI_list LSI_list NI_list SI_list all_list};
    for j = 1:size(region_list,2)
        energy_result{size(regions,2)+j}= combine_region(region_list{j});
    end
end



