function plot_predictions(predictions_object, regression_results,last_year,xlab,no_prudent,all_randomisations,trajectories)
if nargin == 4
    no_prudent = 0;
    all_randomisations=0;
    trajectories = NaN;
end
%This syntax is very similar to the R code. 
actual_peaks = regression_results{7};
actual_years = regression_results{3};
fitted_years = regression_results{3};
fitted_peaks = regression_results{4};
predicted_years = predictions_object(:,1);
expected_peaks = predictions_object(:,5);
maximum_likely_peaks = predictions_object(:,6);
min_year = min(fitted_years);
max_year = min(last_year,max(predicted_years));
min_peak = min(actual_peaks);
loc=find(predicted_years==max_year);
max_peak = max(maximum_likely_peaks(1:loc));
clf
plot(actual_years, actual_peaks, '.')
xlabel(xlab)
axis([min_year max_year 0.9*min_peak max_peak])
hold on
plot(fitted_years, fitted_peaks,'--');
if (all_randomisations == 1)
    for i = 1:size(trajectories{2},2)
        randomisation = trajectories{2}(:,i);
        plot(predicted_years,randomisation,'b-')
    end
end
plot(predicted_years, expected_peaks, 's-');
%plot(predicted_years(2:size(predicted_years,2)),expected_peaks(2:size(predicted_years,2)),'s');
if (no_prudent == 0)
    plot(predicted_years,maximum_likely_peaks,'rx-')
    %plot(predicted_years,maximum_likely_peaks,'rx')
    legend('historical','fitted','predicted','prudent','Location','NorthWest')
end

end


    
