function [predict_results, trajectories] = predict_future_peaks(regress_outputs,energy_forecast_supplied,possible_peakiness_growth,for_years,with_prob,possible_peakiness_growth_2,for_years_2,with_prob_2,poe,record_trajectories,cor_years,corrections,turn_off_interyear_var,n_random_draws)
%add in some default values here. Maybe it's appropriate to move more
%values to here rather than defining back in Control.
if nargin == 12
    turn_off_interyear_var = 0;
    n_random_draws= 1000;
end
%only here for debugging purposes
if 1==0
    possible_peakiness_growth = 1;
    possible_peakiness_growth_2 = 0;
    for_years = 5;
    for_years_2 = 5;
    with_prob = 0.2;
    with_prob_2 = 0;
    poe = 0.1;
    cor_years = cor_years1;
    corrections = corrections1.data(:,2);
end
%Two step process here. Is it possible to do with one?
ri=randperm(size(energy_forecast_supplied,2)-2);
ri=ri(3:n_random_draws+2);

energy_forecast = energy_forecast_supplied(:,[1 2 ri]);                     
n_trajectories = size(energy_forecast,2)-2;
%why is this 'tacked on' in the original R-code? It may as well be its own
%variable
energy_growth = NaN*ones(size(energy_forecast,1));
for i = 2:size(energy_forecast,1)
   energy_growth(i)=100*(energy_forecast(i,2)./energy_forecast(i-1,2)-1); 
end
years=regress_outputs{1}:max(energy_forecast(:,1));                                             %output years here
[a,loc]=ismember(years,energy_forecast(:,1));
energy_growth = energy_growth(loc);                            
energy_prediction = energy_forecast(loc,2);                                
%error catcher here in R code
%The size(years,2) is used often, so I've given it it's own handle
num_of_result_years = size(years,2);
growth_e_peak = NaN*ones(num_of_result_years,1);
for i = 2:6
    growth_e_peak(i)=((7-i)*regress_outputs{5}+(i-2)*(energy_growth(i)))/5;
end
for i = 7:num_of_result_years
    growth_e_peak(i) = energy_growth(i);
end
expected_peak = NaN*ones(num_of_result_years,1);
expected_peak(1) = regress_outputs{2};
for i = 2:num_of_result_years
    expected_peak(i)=expected_peak(i-1).*(1+0.01*growth_e_peak(i));
end
%%Extra MW load added back in here. Loop through all years we predict for
%%and add in sum of all previous loads
for i = 1:size(years,2)
    a=find(cor_years==years(i));                    %match each year to its position in the input table
    if a > 0
        extrabit = sum(corrections(1:a));           %if it's found, sum load from all previous years
    elseif min(cor_years) > years(1)
        extrabit = 0;
        message = 'warning, input loads not complete' %#ok<NOPRT,NASGU>
    else
        extrabit = sum(corrections(1:size(corrections,1))); %otherwhise it must referring to a year after the input table years, so just sum all of them
    end
    expected_peak(i) = expected_peak(i)+extrabit;
end

maximum_likely_peak = NaN*ones(num_of_result_years,1);
peak_trajectories = zeros(num_of_result_years,n_trajectories);
growth_e_peak_2 = zeros(num_of_result_years,n_trajectories);
traj_columns = 3:size(energy_forecast,2);  
energy_forecast_matrix = energy_forecast(:,traj_columns);
for i = 2:6
    [a,this_year_energy_forecast_row]=ismember(years(i),energy_forecast(:,1));
    [a,last_year_energy_forecast_row]=ismember(years(i-1),energy_forecast(:,1));
    
    energy_growth_since_previous_year = 100*(energy_forecast_matrix(this_year_energy_forecast_row,:)./energy_forecast_matrix(last_year_energy_forecast_row,:)-1);
    growth_e_peak_2(i,:) = ((7-i) * regress_outputs{5}*ones(1,n_trajectories)+(i-2)*energy_growth_since_previous_year)/5;
end
for i = 7:num_of_result_years
    [a,this_year_energy_forecast_row]=ismember(years(i),energy_forecast(:,1));
    [a,last_year_energy_forecast_row]=ismember(years(i-1),energy_forecast(:,1));
    growth_e_peak_2(i,:) = 100*(energy_forecast_matrix(this_year_energy_forecast_row,:)./energy_forecast_matrix(last_year_energy_forecast_row,:)-1);
end
peak_trajectories(1,:)=regress_outputs{2};
for i = 2:num_of_result_years
    peak_trajectories(i,:) = peak_trajectories(i-1,:) .* (1+0.01*growth_e_peak_2(i,:));
end
%add in constant MW again
for i = 1:size(years,2)
    a=find(cor_years==years(i));
    if a > 0
        extrabit = sum(corrections(1:a));
    else
        extrabit = sum(corrections(1:size(corrections,1)));
    end
    peak_trajectories(i,2:size(peak_trajectories,2)) = peak_trajectories(i,2:size(peak_trajectories,2))+extrabit;
end
trajectories = cell(3,1);
if (record_trajectories == 1)
    trajectories{1} = years;
    trajectories{2} = NaN*ones(num_of_result_years,n_random_draws);
    trajectories{3} = NaN*ones(num_of_result_years,n_random_draws);
    trajectories{2}(1,:) = expected_peak(1);
    trajectories{3}(1,:) = energy_prediction(1);
end
if (n_random_draws>n_trajectories)
    %not sure how to do this, but it's never going to occur with the code
    %as above. 
elseif n_random_draws == n_trajectories
    traj_to_use=randperm(n_trajectories);
else
    ri = randperm(n_trajectories);
    traj_to_use=ri(1:n_random_draws);
end
for i = 2:num_of_result_years
    peakiness_growth_factor = 1+0.01*possible_peakiness_growth*min(i-1,for_years);
    peakiness_growth_factor_2 = 1+0.01*possible_peakiness_growth_2*min(i-1,for_years_2);
    random_draws = peak_trajectories(i,traj_to_use);
    if (turn_off_interyear_var==0)
        random_draws = random_draws.*(1+regress_outputs{6}/regress_outputs{2}*randn(1,size(traj_to_use,2)));
        for j = 1:n_random_draws
            if (rand<with_prob)
                random_draws(j) = random_draws(j) * peakiness_growth_factor;
            end
            if (rand<with_prob_2)
                random_draws(j) = random_draws(j) * peakiness_growth_factor_2;
            end
        end
    end
       
        
    if (record_trajectories ==1)
        [a,energy_forecast_row_to_use] = ismember(years(i),energy_forecast(:,1));
        trajectories{2}(i,:)=random_draws;
        %I'm really unsure how the extra load will interact with energy
        %forecasts. For regression, it's all accounted for, but I don't
        %know about energy. So I'm not adding it to the energy forecast for
        %now. (It only affects plotting anyway)
        trajectories{3}(i,:)=energy_forecast_matrix(energy_forecast_row_to_use,traj_to_use); %add constant MW here
    end
    sorted_forecasts = sort(random_draws);
    maximum_likely_peak(i) = sorted_forecasts(floor((1-poe)*n_random_draws));
end
predict_results = ones(num_of_result_years,6);
predict_results(:,1) = years;
predict_results(:,2) = energy_growth;
predict_results(:,3) = energy_prediction;
predict_results(:,4) = growth_e_peak;
predict_results(:,5) = expected_peak;
predict_results(:,6) = maximum_likely_peak;
end
    

         
      
        
    


