%regress old peaks
function regress_results = regress_old_peaks(peaks_data,reference_year,period,omit,cor_years,corrections)
%this is a hell of a lot of code to deal with possible missing data points,
%but I suppose it works
    clear rop_years peaks peaks_corrected
    num_years = size(peaks_data,1);
    if period == 1
        for i = 1:num_years
            if isnan(peaks_data(i,4))
            else
                peaks(i) = max(peaks_data(i,2:4));
                rop_years(i) = peaks_data(i,1);
            end
        end
    else
        for i = 1:num_years
            if isnan(peaks_data(i,4))
            else
                peaks(i) = peaks_data(i,period);
                rop_years(i) = peaks_data(i,1);
            end
        end
        %Here's an attempt to do things without loops, but I can't get
        %proper "errors".
        %peaks = peaks_data(:,period).*(isnan(peaks_data(:,4))-1)*-1;
        %years = peaks_data(:,1).*(isnan(peaks_data(:,4))-1)*-1;
    end
    peaks=peaks(:);
    %take off fixed load for regression purposes. Lots of code to match
    %correct years
    [a,loc]=ismember(rop_years,cor_years);
    peaks_corrected = ones(size(peaks,1),1);
    for i = 1:size(peaks,1)
        if loc(i) > 0
            peaks_corrected(i) = peaks(i) - corrections(loc(i));
        else
            peaks_corrected(i) = peaks(i);
        end
    end
    
    %correctedpeaks = peaks
    rop_years=rop_years(:);
    plot(rop_years,peaks,'.');
    %Then set about performing the regression
    weights = 1.4.^min(rop_years-2007+2,0);  %2007 = max(rop_years)
    for j = 1:size(rop_years,1)
        if sum(rop_years(j) == omit) == 1
            weights(j) = 0;
        end
    end
    weights = sqrt(weights);
    %weights=ones(11,1);
    p = polyfitweighted(rop_years,log(peaks_corrected),1,weights);    
    %I've compared the two functions (R and matlab) side by side with
    %uniform weight and they're idnetical. Significant differences are
    %introduced when I use weightings.
    growth_rate = 0.01*floor(10000*(exp(p(1))-1));
    fitted_values = exp(rop_years*p(1)+p(2));
    hold on
    plot(rop_years, fitted_values);
    residuals = peaks_corrected-fitted_values;
    %in the r-code this is accomplished via 1 line. I don't know how to
    %create an array of indeterminate length so simply in matlab, so I'm
    %doing it with a loop. 
    count = 1;
    for i = 1:size(rop_years,1)
        if sum(rop_years(i) == omit) == 0
            residuals_less_omitted(count) = residuals(i); %#ok<AGROW>
            count=count+1;
        end
    end
    rmse = sqrt(mean(residuals_less_omitted.*residuals_less_omitted));
    prediction_in_reference_year = exp(reference_year*p(1)+p(2));
    
    %result_names= {'reference_year' 'fitted_value_in_reference_year' 'fitted_years' 'fitted_values' 'growth_rate' 'rmse' 'observed_peaks' 'observed_years'};
    regress_results{1}=reference_year;
    regress_results{2}=prediction_in_reference_year;
    regress_results{3}=rop_years;
    regress_results{4}=fitted_values;
    regress_results{5}=growth_rate;
    regress_results{6}=rmse;
    regress_results{7}=peaks;
    %regress_results{8}=rop_years; % I don't see the difference to {3}
    end

